<head>
  <script
    src="https://code.jquery.com/jquery-3.7.0.min.js"
    integrity="sha256-2Pmvv0kuTBOenSvLm6bvfBSSHrUJ+3A7x6P5Ebd07/g="
    crossorigin="anonymous"
  ></script>
</head>
<body>
  <button id="login" onclick="AuthorizationCode()">login</button>
  <script src="./env.js"></script>
  <script>
    const { AUTH_URL, AUTH_CLIENT_ID, AUTH_CLIENT_SECRET, AUTH_CLIENT_CALLBACK_URI, AUTH_CLIENT_SCOPE } = process.env

    const buidQs = (params) => {
      return Object.keys(params)
        .map((key) => {
          return encodeURIComponent(key) + '=' + encodeURIComponent(params[key])
        })
        .join('&')
    }

    const AuthorizationCode = async () => {
      const textEncoder = new TextEncoder()

      function randomString(length) {
        let result = ''
        const characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789'
        const charactersLength = characters.length
        for (let i = 0; i < length; i++) {
          result += characters.charAt(Math.floor(Math.random() * charactersLength))
        }
        return result
      }

      async function sha256(str) {
        if (!crypto.subtle) console.error('')
        return new Uint8Array(await crypto.subtle.digest('SHA-256', textEncoder.encode(str)))
      }

      function toHex(uint8Array) {
        const hashArray = Array.from(uint8Array)
        const hashHex = hashArray.map((b) => b.toString(16).padStart(2, '0')).join('')
        return hashHex
      }

      function hexToBase64(str) {
        return btoa(
          String.fromCharCode.apply(
            null,
            str
              .replace(/\r|\n/g, '')
              .replace(/([\da-fA-F]{2}) ?/g, '0x$1 ')
              .replace(/ +$/, '')
              .split(' ')
          )
        )
      }
      const codeVerifier = randomString(64)
      window.sessionStorage.setItem('codeVerifier', codeVerifier)
      const codeChallenge = hexToBase64(toHex(await sha256(codeVerifier)))
        .replace(/[\+]/g, '-')
        .replace(/[\/]/g, '_')
        .replace(/[=]/g, '')

      const obj = {
        client_id: 'aio-client',
        grant_type: 'authorization_code',
        // 'resource': '',
        response_type: 'code',
        redirect_uri: env.AUTH_CLIENT_CALLBACK_URI,
        scope: 'openid offldine_access profile',
        prompt: 'consent',
        code_challenge: codeChallenge,
        code_challenge_method: 'S256',
      }

      window.location.href = env.AUTH_URL + '/auth?' + buidQs(obj)
    }
  </script>
</body>
